"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.SmartFeedApi = void 0;
const rest_client_1 = require("./rest-client");
const smart_feed_1 = require("./smart-feed");
class SmartFeedApi {
    constructor(config) {
        this.config = config;
        this.restClient = new rest_client_1.RestClient(this.config);
    }
    getFeeders() {
        return __awaiter(this, void 0, void 0, function* () {
            const feeders = yield this.restClient.request({
                url: (0, rest_client_1.apiPath)('feeders'),
            });
            return feeders.map((info) => {
                return new smart_feed_1.SmartFeed(info, this.restClient);
            });
        });
    }
}
exports.SmartFeedApi = SmartFeedApi;
