"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.generateRefreshToken = void 0;
/* eslint-disable no-console */
const util_1 = require("./util");
const auth_1 = require("./auth");
function getTokens(initiateAuthOutput) {
    return __awaiter(this, void 0, void 0, function* () {
        let output;
        try {
            output = yield (0, auth_1.getAuthTokens)(initiateAuthOutput, yield (0, util_1.requestInput)('Code: '));
        }
        catch (e) {
            console.error(e.message);
            void e;
        }
        if (!(output === null || output === void 0 ? void 0 : output.AuthenticationResult)) {
            console.error('Authentication failed. Please check your code and try again.');
            return getTokens(initiateAuthOutput);
        }
        return output.AuthenticationResult;
    });
}
function generateRefreshToken() {
    return __awaiter(this, void 0, void 0, function* () {
        console.log('This CLI will provide you with a token which you can use to configure homebridge-petsafe-smart-feed. Please enter your email address to start the process.');
        const email = yield (0, util_1.requestInput)('Email: '), initiateAuthOutput = yield (0, auth_1.initiateAuth)(email);
        console.log('You should now receive an email from PetSafe.  Please enter the code from that email below.');
        const tokens = yield getTokens(initiateAuthOutput);
        console.log('\nSuccessfully logged in to PetSafe. Please use the following line in your homebridge config:\n');
        console.log(`"token": "${tokens.RefreshToken}"`);
    });
}
exports.generateRefreshToken = generateRefreshToken;
