"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.requestInput = exports.delay = exports.enableDebug = exports.useLogger = exports.logError = exports.logInfo = exports.logDebug = void 0;
const readline_1 = require("readline");
let logger = {
    logInfo(message) {
        // eslint-disable-next-line no-console
        console.info(message);
    },
    logError(message) {
        // eslint-disable-next-line no-console
        console.error(message);
    },
}, debugEnabled = false;
function logDebug(message) {
    if (debugEnabled) {
        logger.logInfo(message);
    }
}
exports.logDebug = logDebug;
function logInfo(message) {
    logger.logInfo(message);
}
exports.logInfo = logInfo;
function logError(message) {
    logger.logError(message);
}
exports.logError = logError;
function useLogger(newLogger) {
    logger = newLogger;
}
exports.useLogger = useLogger;
function enableDebug() {
    debugEnabled = true;
}
exports.enableDebug = enableDebug;
function delay(milliseconds) {
    return new Promise((resolve) => {
        setTimeout(resolve, milliseconds);
    });
}
exports.delay = delay;
function requestInput(question) {
    return __awaiter(this, void 0, void 0, function* () {
        const lineReader = (0, readline_1.createInterface)({
            input: process.stdin,
            output: process.stdout,
        }), answer = yield new Promise((resolve) => {
            lineReader.question(question, resolve);
        });
        lineReader.close();
        return answer.trim();
    });
}
exports.requestInput = requestInput;
